package ca.odell.glazedlists.impl;

/**
 * A utility class containing all sorts of random things that are useful for
 * implementing Glazed Lists but not for using Glazed Lists.
 *
 * @author <a href="mailto:jesse@odel.on.ca">Jesse Wilson</a>
 */
public final class GlazedListsImpl {
    
    /**
     * A dummy constructor to prevent instantiation of this class
     */
    private GlazedListsImpl() {
        super();
        throw new UnsupportedOperationException();
    }
    
    /**
     * Compare the specified objects for equality.
     */
    public static boolean equal(Object a, Object b) {
        if (a == b) return true;
        if (a == null || b == null) return false;
        return a.equals(b);
    }
}
